
precision highp float;

varying highp vec2 textureCoordinate;
uniform sampler2D inputTexture;
uniform sampler2D blurTexture;
uniform sampler2D blurTexture2;
uniform sampler2D maskTexture;

uniform float nasolabialStrength;

void main(){
    vec4 color = texture2D(inputTexture, textureCoordinate.xy);
    vec4 maskColor = texture2D(maskTexture, textureCoordinate.xy);

    if(nasolabialStrength != 0.0){
        vec3 blurColor1 = texture2D(blurTexture, textureCoordinate.xy).rgb;
        vec3 blurColor2 = texture2D(blurTexture2, textureCoordinate.xy).rgb;
        vec3 diffColor = clamp((blurColor2 - blurColor1) * 1.2 + 0.02 * blurColor2, 0.0, 0.5);
        color.rgb = mix(color.rgb, min(color.rgb + diffColor, 1.0), nasolabialStrength * maskColor.r);
    }

    gl_FragColor = color;
}