precision highp float;

varying vec2 textureCoordinate;
uniform sampler2D inputImageTexture;
uniform sampler2D inputImageTexture2;
uniform sampler2D inputImageTexture3;

const vec3 grayXfer = vec3(0.3, 0.59, 0.11);

void main(){

    vec4 color = texture2D(inputImageTexture, textureCoordinate);
    vec3 blurColor1 = texture2D(inputImageTexture2, textureCoordinate).rgb;
    vec3 blurColor2 = texture2D(inputImageTexture3, textureCoordinate).rgb;
    vec3 diffColor = clamp((blurColor2 - blurColor1) * 1.2 + 0.02 * blurColor2, 0.0, 0.5);
    color.rgb = mix(color.rgb, min(color.rgb + diffColor, 1.0), 1.0);

    //    gl_FragColor = vec4(blurColor1, 1.);
    gl_FragColor= color;

}